"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class BoundingBox(google.protobuf.message.Message):
    """BoundingBox represents the bounding box data structure"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOP_FIELD_NUMBER: builtins.int
    LEFT_FIELD_NUMBER: builtins.int
    WIDTH_FIELD_NUMBER: builtins.int
    HEIGHT_FIELD_NUMBER: builtins.int
    top: builtins.float
    """Bounding box top y-axis value"""
    left: builtins.float
    """Bounding box left x-axis value"""
    width: builtins.float
    """Bounding box width value"""
    height: builtins.float
    """Bounding box height value"""
    def __init__(
        self,
        *,
        top: builtins.float = ...,
        left: builtins.float = ...,
        width: builtins.float = ...,
        height: builtins.float = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["height", b"height", "left", b"left", "top", b"top", "width", b"width"]) -> None: ...

global___BoundingBox = BoundingBox

@typing_extensions.final
class ExtraParamObject(google.protobuf.message.Message):
    """Additional hyperparameters for model inferences
    or other configuration not listsed in protobuf
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARAM_NAME_FIELD_NUMBER: builtins.int
    PARAM_VALUE_FIELD_NUMBER: builtins.int
    param_name: builtins.str
    """Name of the hyperparameter"""
    param_value: builtins.str
    """Value of the hyperparameter"""
    def __init__(
        self,
        *,
        param_name: builtins.str = ...,
        param_value: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["param_name", b"param_name", "param_value", b"param_value"]) -> None: ...

global___ExtraParamObject = ExtraParamObject

@typing_extensions.final
class PromptImage(google.protobuf.message.Message):
    """Prompt Image for text generation model"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROMPT_IMAGE_URL_FIELD_NUMBER: builtins.int
    PROMPT_IMAGE_BASE64_FIELD_NUMBER: builtins.int
    prompt_image_url: builtins.str
    """Image URL"""
    prompt_image_base64: builtins.str
    """Base64 encoded Image"""
    def __init__(
        self,
        *,
        prompt_image_url: builtins.str = ...,
        prompt_image_base64: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["prompt_image_base64", b"prompt_image_base64", "prompt_image_url", b"prompt_image_url", "type", b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["prompt_image_base64", b"prompt_image_base64", "prompt_image_url", b"prompt_image_url", "type", b"type"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["type", b"type"]) -> typing_extensions.Literal["prompt_image_url", "prompt_image_base64"] | None: ...

global___PromptImage = PromptImage

@typing_extensions.final
class ImageContent(google.protobuf.message.Message):
    """Image content for Message Content"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    IMAGE_URL_FIELD_NUMBER: builtins.int
    DETAIL_FIELD_NUMBER: builtins.int
    @property
    def image_url(self) -> global___PromptImage:
        """Image url or base64 code of Message Content"""
    detail: builtins.str
    """Additinoal information for Image Content"""
    def __init__(
        self,
        *,
        image_url: global___PromptImage | None = ...,
        detail: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["_detail", b"_detail", "detail", b"detail", "image_url", b"image_url"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["_detail", b"_detail", "detail", b"detail", "image_url", b"image_url"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["_detail", b"_detail"]) -> typing_extensions.Literal["detail"] | None: ...

global___ImageContent = ImageContent

@typing_extensions.final
class MessageContent(google.protobuf.message.Message):
    """Content used for chat history message in text generation model"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    IMAGE_URL_FIELD_NUMBER: builtins.int
    TEXT_FIELD_NUMBER: builtins.int
    type: builtins.str
    """Type of Content"""
    @property
    def image_url(self) -> global___ImageContent:
        """Image Url is the naming convention by openAi but not necessarily a url"""
    text: builtins.str
    """Field for text"""
    def __init__(
        self,
        *,
        type: builtins.str = ...,
        image_url: global___ImageContent | None = ...,
        text: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["content", b"content", "image_url", b"image_url", "text", b"text"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["content", b"content", "image_url", b"image_url", "text", b"text", "type", b"type"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["content", b"content"]) -> typing_extensions.Literal["image_url", "text"] | None: ...

global___MessageContent = MessageContent

@typing_extensions.final
class Message(google.protobuf.message.Message):
    """Message used for chat history in text generation model"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ROLE_FIELD_NUMBER: builtins.int
    CONTENT_FIELD_NUMBER: builtins.int
    role: builtins.str
    """The Role of a message"""
    @property
    def content(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___MessageContent]:
        """The context of the message"""
    def __init__(
        self,
        *,
        role: builtins.str = ...,
        content: collections.abc.Iterable[global___MessageContent] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["content", b"content", "role", b"role"]) -> None: ...

global___Message = Message
